import { WebPlugin } from '@capacitor/core';
import type { FirebaseMessagingPlugin, GetDeliveredNotificationsResult, GetTokenOptions, GetTokenResult, IsSupportedResult, PermissionStatus, RemoveDeliveredNotificationsOptions, SubscribeToTopicOptions, UnsubscribeFromTopicOptions } from './definitions';
export declare class FirebaseMessagingWeb extends WebPlugin implements FirebaseMessagingPlugin {
    static readonly notificationReceivedEvent = "notificationReceived";
    constructor();
    checkPermissions(): Promise<PermissionStatus>;
    requestPermissions(): Promise<PermissionStatus>;
    isSupported(): Promise<IsSupportedResult>;
    getToken(options: GetTokenOptions): Promise<GetTokenResult>;
    deleteToken(): Promise<void>;
    getDeliveredNotifications(): Promise<GetDeliveredNotificationsResult>;
    removeDeliveredNotifications(_options: RemoveDeliveredNotificationsOptions): Promise<void>;
    removeAllDeliveredNotifications(): Promise<void>;
    subscribeToTopic(_options: SubscribeToTopicOptions): Promise<void>;
    unsubscribeFromTopic(_options: UnsubscribeFromTopicOptions): Promise<void>;
    private handleNotificationReceived;
    private createNotificationResult;
    private convertNotificationPermissionToPermissionState;
    private throwUnavailableError;
}
